/*
  A simple program that count words from a file
  and print with some statistics.
*/

#include <iostream>
#include <fstream>
#include <cmath>

// from STL
#include <string>
#include <map>

/*
  > main pippo pluto

  argc = 3
  argv[0] = "main"
  argv[1] = "pippo"
  argv[2] = "pluto"
  
  Usage of the program
  
  > main filename
  
 */
 
using namespace std ;

int
main( int argc, char * argv[] ) {
  string fileName ;

  if ( argc > 2 ) {
    // too nuch argument, issue an error
    cerr << "usage: " << argv[0] << " file\n" ;
    return 1 ;
  }

  if ( argc == 1 ) {
    // only one argument, ask to the user the file name
    cout << "File: " ;
    cin >> fileName ; 
  } else {
    // two argument, get file name from command line
    fileName = argv[1] ;
  }
  
  // open the file
  ifstream file( fileName . c_str() ) ;
  
  // check if the file exist is opened etc.
  if ( file . bad() ) {
    cerr << "error in openeing : " << fileName << "\n" ;    
    return 1 ; 
  }
  
  map<string,int> wc ; // associative array to store word count
  
  // loop to read all the words
  while ( file . good() ) {
    string w ;
    file >> w ;
    
    // check if w is present in the associative array wc
    map<string,int>::iterator i = wc.find(w) ;
    if ( i == wc.end() ) {
      // element not found
      wc[w] = 1 ;
    } else {
      // element found!
      // wc[w]++ ;
      // i->first  keyword
      // i->second value
      i->second++ ;
    }
  }

  // close the file
  file . close() ;
  
  // write the output
  for ( map<string,int>::const_iterator i = wc.begin() ; i != wc.end() ; ++i ) {
    cout << i -> first << " " << i -> second << "\n" ;
  }
}
